# Le yojik

## Le site FSI-languages.yojik.eu ou www.yojik.eu

Le yojik est le site que j'ai développé dans les années 2006 quand j'ai loué mon premier serveur chez OVH. Plusieurs versions se sont échelonnées au cours des années.

Les ressources FSI et DLI (cours de langues du Foreign Service Institute, Defense Language Institute, PeaceCorps) étaient jusqu'alors disponibles sur un site qui regroupait tout ce qui avait pu être sauvé avant l'utilisation par ces organismes de ressources propriétaires et numériques.

Le site a disparu du jour au lendemain, et j'ai reconstitué à partir du site **archive.org** ainsi que l'aide de quelques personnes du forum de langues l'intégralité des cours. Dans les faits, nous avons même augmenté considérément le nombre de cours disponibles.

Un travail de 2 ans a permis de sauver les cours Cortina. (ceux dont on a pu négocier les droits)

Les cours sont assez anciens, mais sont l'aboutissement de dizaines d'années de recherche et d'essais dans l'apprentissage des langues. Les cours sont souvent remarquables (j'aurai adoré avoir des cours comme ça quand j'étais au collège/lycée). Les cours **FSI** sont destinés à un apprentissage rapide, souvent sur quelques mois, tandis que les cours **DLI** sont beaucoup plus approfondis.

Ces cours sont en anglais.

Des cours similaires existent sûrement dans les écoles militaires françaises (et d'autres pays) ou autre département des affaires étrangères, mais nous n'y avons pas accès.

C'est dommage :( (car développés avec de l'argent public)

Voici les liens:

* [Le Yojik](https://www.yojik.eu)
* [FSI languages](https://fasi-languages.yojik.eu)

## La forge git sur le Yojik

J'ai installé une forge git ouverte sur le Yojik: [ici](https://git.yojik.eu)

Vous y trouverez un très grand nombre de ressources pour l'étude des langues sous forme de listes de vocabulaires/phrases formatées en .csv, .json et .xml.

3 formats pour en faciliter l'iutilisation dans différenets logiciesl. Référez-vous à l'article sur Anki pour en voir une utilisation possible.

Se trouvent également sur cette forge mes travaux de numérisation des documents FSI et DLI ainsi que la création d'ebooks en format .epub (version3, avec audio incluse). Ces livres électroniques sont créés à partir des documents FSI, DLI numérisés ainsi qu'à partir de cours de langues glannés sur le web et mis en forme pour leur utilisation sur une tablette/téléphine/portable sans être connecté à Internet.

Cela me permet aussi de leur donner un style identique, ce qui dans mon cas me permet de mieux retenir.

Il faut ajouter que la création de ces livres électroniques permet de **travailler avec la langue**: on ne peut passer toute la journée à étudier le même sujet; passer par l'écriture (il y a toujours des choses à ajouter aux livres, corrections, traductions etc.) est un bon complément à l'étude classique.

J'ai pu écrire un grand nombre de programmes d'importation, transformation, formattage dans un langage que je ne connaissais pas encore: javascript/typescript. Cela a été assez amusant!

## Le Shtooka

En 2006, Nicolas Vion (et autres dont moi-même) a créé le site **shtooka.net**. Ce site était dévolu à la mise à disposition de vocabulaire enregistré dans différentes langues, par des locuteurs natifs.

Ce site a eu un grand succès. Ma femme a enregistré une bonne partie du vocabulaire russe. Il serait intéressant de le refaire revivre: mise à jour des programmes d'enregistrement et tagguage, ajout de collections de mots; ajout de collections de phrases.

Les données audio sont tagguées avec des informations technique (qui a enregistré, d'où il/elle vient, son âge etc.) ainsi que des données linguistiques.

Différentes collections de vocabulaire ont été enregistrées et peuvent être téléchargées dans la section **Shtooka: collections audio**. J'ai gardé une copie de l'ancien site Shtooka, ainsi que de l'ensemble des collections audio.

Ces 2 sites sont accessibles à partir du site [Le Yojik](https://www.yojik.eu)
