# Annexe

Au fur et à mesure de mes pérégrinations autour du Raspi, j'ai découvert une façon plus rapide pré-configurer l'installation.

Une fois l'étape de copie de l'image efféctuée, montez votre carte SD sur votre desktop.

Il y aura 2 partitions:

* rootfs
* boot
  
Dans la partition **boot**, créez un fichier **ssh** vide avec la commande suivante:

    touch ssh

Ensuite, déplacez-vous dans la partition **rootfs**. Vous y trouverez toute l'arborescence de votre future installation. Allez dans le répertoire **etc**. Ici, vous allez pouvoir configurer:

* le hostname
  
    Comme déjà indiqué, le hostname sur Debian est partagé entre 2 fichiers:

    - /etc/hostname
        Il ne contient que le petit nom de votre machine, **piras** dans mon cas.
    
    - /etc/hosts
        Il contient la configuration complète du hostname. En voici le contenu modifié:

            pi@piras:~$ cat /etc/hosts
            127.0.0.1    localhost

            192.168.111.170  piras.yojik.net piras

            # The following lines are desirable for IPv6 capable hosts
            ::1     localhost ip6-localhost ip6-loopback
            ff02::1 ip6-allnodes
            ff02::2 ip6-allrouters
            pi@piras:~$

        170 est l'adresse définitive de mon serveur (IPV4)

        
* le réseau

    Pour attribuer une adresse IPV4 fixe à notre raspi, dès le premier lancement, nous pouvons éditer le fichier **/etc/dhcpcd.conf** avant de démonter notre carte SD.

    Voilà la partie à modifier:


        # Example static IP configuration:
        interface eth0
        static ip_address=192.168.111.170/24
        static ip6_address=2a01:e0a:d0:3c20::170/64
        static routers=192.168.111.254
        #static domain_name_servers=192.168.1.1
    
    Nous gardons la partie domain_name_servers commentée en attendant d'avoir configuré le resolveur DNS ** knot-resolver**.

Une fois cela fait, nous pouvons démonter notre carte SD et l'insérer dans le raspi. Le réseau et le hostname seront réconfigurés. Ce sera également plus simple car cela nous évitera de devoir modifier le fichier **/etc/hosts** de notre desktop, ainsi que le fichier **.ssh/config** dans le répertoire **home** de notre desktop.
