# Installation de base

## Copie de l'image sur la carte SD

Je vais utiliser la distribution "Raspbian", dérivée d'un système Debian classique.

Elle a changé récemment de nom ... j'espère qu'ils ne vont pas abandonner le système de paquetage de Debian. 

Vous pouvez récupérer l'image directement sur [RaspberryPi.org](https://raspberrypi.org).

Repérez ensuite la référence à votre carte microSD avec la commande suivante (dans un terminal); voilà un example de sortie terminal (la carte microSD a été placée dans un adaptateur usb):

    eric@aldebaran:~$ lsblk
    NAME    MAJ:MIN RM   SIZE RO TYPE  MOUNTPOINT
    sda       8:0    0   1,8T  0 disk  
    ├─sda1    8:1    0   1,4T  0 part  /mnt/Busterhome
    └─sda2    8:2    0   466G  0 part  /home
    sdb       8:16   0 223,6G  0 disk  
    ├─sdb1    8:17   0   500M  0 part  /boot/efi
    ├─sdb2    8:18   0  1000M  0 part  /boot
    ├─sdb3    8:19   0  97,7G  0 part  /mnt/Busterroot
    ├─sdb4    8:20   0  97,7G  0 part  /
    └─sdb5    8:21   0  26,8G  0 part  [SWAP]
    sdc       8:32   0   3,6T  0 disk  
    └─sdc1    8:33   0   3,6T  0 part  
    └─md0     9:0    0   3,6T  0 raid1 /mnt/Raid
    sdd       8:48   0   3,6T  0 disk  
    └─sdd1    8:49   0   3,6T  0 part  
    └─md0     9:0    0   3,6T  0 raid1 /mnt/Raid
    sde       8:64   1   1,8G  0 disk  /media/eric/9E40-CF6B
    eric@aldebaran:~$ 

La carte microSD est référencée à la dernière ligne: **sde**

Un autre example avec la carte microSD placée dans directement dans un adaptateur intégré dans un portable.

![Image des interfaces bloc](../../Images/tutoraspi/Capture d’écran de 2021-02-10 10-11-28.png)

La commande pour copier l'image Raspbian sur la carte microSD est la suivante:

    eric@aldebaran:~$ dd if=2020-08-20-raspios-buster-armhf-lite.img of=/dev/sde bs=4096

C'est une commande que j'utilise systématiquement avec le paramètre **bs** mis à 4096. Je ne me souviens plus pourquoi il m'avait fallu mettre ce paramètre, mais cela fonctionne bien avec (et moins bien sans.)

Une autre version de cette commande découverte avec (FreedomBox)[https://www.freedombox.org] est la suivante: (test avec la dernière version de RaspiOS ... changement de nom par rapport à Raspbian, car contient des "trucs" pas vraiment libres comme les dépots de Microsoft (VsCode) :( ))

    $ sudo dd bs=1M if=2021-01-11-raspios-buster-armhf-lite.img of=/dev/sdd conv=fdatasync status=progress
    1816133632 octets (1,8 GB, 1,7 GiB) copiés, 1 s, 1,8 GB/s
    1776+0 enregistrements lus
    1776+0 enregistrements écrits
    1862270976 octets (1,9 GB, 1,7 GiB) copiés, 167,27 s, 11,1 MB/s
    eric@aldebaran:~$


Une autre commande possible est (trouvée également sur le site de FreedomBox):

    $ cat 2021-01-11-raspios-buster-armhf-lite.img > /dev/sdd ; sync

Bien sûr, changez le périphérique suivant votre cas particulier: le mien, ici, est **/dev/sdd**. Voyez avec la commande **lsblk** pour découvrir la votre: elle change avec les périphériques déjà branchés sur votre ordinateur. (chez moi, la première fois, c'était **/dev/sde**, puis aujourd'hui, **/dev/sdd**)
## Autorisation de l'accès en ssh

Pour pouvoir se connecter en **ssh**, il faut créer un fichier vide de nom **ssh** dans le répertoire **/boot**.

voici la liste des commandes nécessaires:

    cd /media/eric/9E40-CF6B/boot
    touch ssh

/media/eric/9E40-CF6B/boot est le point de montage de la carte microsd sur le desktop.

Une fois cela fait, vous pouvez démonter votre carte microSD et la placer dans votre raspi.
