# Premier démarrage

Insérerez la carte microSD dans le connecteur adéquat, le câble ethernet et pour finir l'alimentation.

Les petites leds situées sur la carte raspi doivent s'allumer et certaines d'entre elles vont passer au vert.

Pour pouvoir ensuite se connecter sur votre raspi en **ssh**, il faut trouver son adresse **IP** qui est attribuée automatiquement par votre **box** en dhcp.

Nous verrons ensuite comment attribuer une adresse IP fixe à votre raspi.

## Découverte de l'adresse IP de votre raspi

Il y a plusieurs méthodes suivant que votre poste principal est sous Windows, MacOs ou Linux. Je ne traiterai que le cas Linux, car je n'ai ni Windows, ni MacOs.

### En ligne de commande dans un terminal

    eric@aldebaran:~$ sudo nmap -sn 192.168.111.0/24
    [sudo] Mot de passe de eric : 
    Starting Nmap 7.91 ( https://nmap.org ) at 2020-12-11 10:43 CET
    Nmap scan report for 192.168.111.13
    Host is up (0.13s latency).
    MAC Address: 20:D3:90:EA:EE:9E (Samsung Electronics)
    Nmap scan report for 192.168.111.20
    Host is up (0.14s latency).
    MAC Address: 90:78:B2:A1:31:E7 (Xiaomi Communications)
    Nmap scan report for 192.168.111.25
    Host is up (0.24s latency).
    MAC Address: D8:12:65:5B:DD:90 (Chongqing Fugui Electronics)
    Nmap scan report for 192.168.111.32
    Host is up (0.00074s latency).
    MAC Address: B8:27:EB:3A:0B:38 (Raspberry Pi Foundation)
    Nmap scan report for 192.168.111.34
    Host is up (0.23s latency).
    MAC Address: 00:73:8D:92:7E:B6 (Shenzhen Tinno Mobile Technology)
    Nmap scan report for 192.168.111.49
    Host is up (0.25s latency).
    MAC Address: 70:EE:50:6B:7B:3A (Netatmo)
    Nmap scan report for 192.168.111.140
    Host is up (0.26s latency).
    MAC Address: 98:DA:C4:37:BF:F9 (Tp-link Technologies)
    Nmap scan report for 192.168.111.151
    Host is up (0.00011s latency).
    MAC Address: D0:50:99:A5:69:C5 (ASRock Incorporation)
    Nmap scan report for 192.168.111.160
    Host is up (0.00029s latency).
    MAC Address: 00:23:54:C6:0A:07 (Asustek Computer)
    Nmap scan report for 192.168.111.250
    Host is up (0.69s latency).
    MAC Address: A8:6B:AD:00:D3:E4 (Hon Hai Precision Ind.)
    Nmap scan report for 192.168.111.254
    Host is up (0.00077s latency).
    MAC Address: 68:A3:78:65:7B:5C (Freebox SAS)
    Nmap scan report for 192.168.111.150
    Host is up.
    Nmap done: 256 IP addresses (12 hosts up) scanned in 27.11 seconds
    eric@aldebaran:~$ 

Vous voyez toutes les machines connectées sur le réseau familial (oui, il y a des ampoules connectées ;), ainsi que la station météo et les capteurs additionnels.)

Pour scanner votre réseau en IPV6, la commande est la suivante:

    eric@aldebaran:~$ sudo nmap -6 -sn 2a01:e0a:d0:3c20::0/64

Elle prend des "plombes" à s'exécuter vu le nombre d'adresses à tester ...

> Il est aussi possible de récupérer l'adresse IPV6 sur la console d'administration de votre box. (voir plus bas)

La ligne qui nous intéresse est celle qui référence notre raspi:

    MAC Address: D8:12:65:5B:DD:90 (Chongqing Fugui Electronics)
    Nmap scan report for 192.168.111.32
    Host is up (0.00074s latency).
    MAC Address: B8:27:EB:3A:0B:38 (Raspberry Pi Foundation)

L'adresse IP (IPV4) est: 192.168.111.32

Cette adresse a été attribuée dynamiquement. Il nous faudra lui attribuer une adresse IP fixe, en IPV4 et IPV6.

### Retrouver l'adresse IP avec la Freebox

Vous pouvez accéder à l'interface web de votre Freebox à l'adresse: [FreeboxOs](http://mafreebox.freebox.fr/)

Voilà une série de captures d'écran qui vous permettront de trouver l'adresse IP de votre raspi. Le mien a déjà été configuré avec le nom **piras**.

![copie d'écran](../../Images/tutoraspi/Capture%20d’écran%20de%202020-12-11%2010-49-15.png)

![copie d'écran](../../Images/tutoraspi/Capture%20d’écran%20de%202020-12-11%2010-49-30.png)

![copie d'écran](../../Images/tutoraspi/Capture%20d’écran%20de%202020-12-11%2010-49-44.png)


## Première connexion en SSH

La commande est à effectuer dans un terminal est la suivante:

    eric@aldebaran:~$ ssh pi@192.168.111.32
    pi@192.168.111.32's password: 
    Linux piras 5.4.51+ #1333 Mon Aug 10 16:38:02 BST 2020 armv6l

    The programs included with the Debian GNU/Linux system are free software;
    the exact distribution terms for each program are described in the
    individual files in /usr/share/doc/*/copyright.

    Debian GNU/Linux comes with ABSOLUTELY NO WARRANTY, to the extent
    permitted by applicable law.
    Last login: Sun Nov 29 16:03:52 2020 from 192.168.111.150
    pi@piras:~ $ 

Nous sommes connectés.

L'utilisateur prédéfini avec les droits **sudo** d'administration est **pi** et le mot de passe par défaut est **raspberry**.

Changez ce mot de passe avec la commande suivante:

    passwd

et suivez les instructions. Pensez à utiliser un mot de passe fort, par exemple généré avec le programme **pwgen** (voir les tutos: **Installation d'un serveur Debian/Stretch sécurisé** et **Installation d'un serveur Debian/Buster sécurisé**.)

## premières configuration

Tapez:

    sudo raspi-config

et configurez le clavier, la langue, l'extension des partitions à tout l'espace disponible sur la clef, le hostname, la **time-zone** et n'oubliez pas da faire un update/upgrade avant de re-démarrer.

* Le clavier (commencez par là)
  
    Choisissez le clavier français azerty. (ou autre selon votre configuration personnelle)

* Les locales

    Ajouter fr_FR.UTF8 et régénérez vos locales

    Choix du paramètre actif par défaut: fr_FR.UTF8

    ![locale](../../Images/tutoraspi/Capture%20d’écran%20de%202021-02-14%2011-02-29.png)

    sudo apt update && sudo apt upgrade

* Zone (fuseau horaire)

    Choisissez **Europe/Paris** si c'est bien votre zone!

* Options avancées

    Agrandissez vos partitions pour qu'elles occupent tout l'espace disponible sur le care SD (option A1)

Rdémarrez votre Raspi.

Au prochain rédamarrage, faites une mis à jour générale de votre système avec la commande suivante qui redémarrera votre raspi à la fin des opérations:

    pi@raspberrypi:~ $ sudo apt update && sudo apt upgrade && sudo systemctl reboot
    Réception de :1 http://raspbian.raspberrypi.org/raspbian buster InRelease [15,0 kB]
    Atteint :2 http://archive.raspberrypi.org/debian buster InRelease                                      
    Réception de :3 http://packages.microsoft.com/repos/code stable InRelease [10,4 kB]                    
    Réception de :4 http://raspbian.raspberrypi.org/raspbian buster/main armhf Packages [13,0 MB]
    Réception de :5 http://packages.microsoft.com/repos/code stable/main armhf Packages [13,6 kB]                                                    
    Réception de :6 http://packages.microsoft.com/repos/code stable/main arm64 Packages [13,6 kB]                                                    
    Réception de :7 http://packages.microsoft.com/repos/code stable/main amd64 Packages [13,0 kB]                                                    
    13,1 Mo réceptionnés en 38s (340 ko/s)                                                                                                           
    Lecture des listes de paquets... Fait
    Construction de l'arbre des dépendances       
    Lecture des informations d'état... Fait
    Tous les paquets sont à jour.
    Lecture des listes de paquets... Fait
    Construction de l'arbre des dépendances       
    Lecture des informations d'état... Fait
    Calcul de la mise à jour... Fait
    0 mis à jour, 0 nouvellement installés, 0 à enlever et 0 non mis à jour.
    pi@raspberrypi:~ $    

Vous trouverez ces instructions sur de nombreux tutoriels et je ne vais pas les répêter.

Voyez les tutoriaux sur la sections tutoriaux du site [RaspberryPi.org](https://raspberrypi.org) par exemple, mais il y en a d'autres.
