# Réseau

Dans cette partie, nous allons donner à notre raspi une adresse IP fixe, en IPV4 et IPV6.

Nous allons utiliser ce qui est indiqué dans de nombreux tutoriels: modification du fichier **/etc/dhcpcd.conf**

    # Example static IP configuration:
    interface eth0
    static ip_address=192.168.111.170/24
    static ip6_address=2a01:e0a:d0:3c20::170/64
    static routers=192.168.111.254
    #static domain_name_servers=192.168.1.1

Les lignes à modifier sont celles ci-dessus: enlever le **#** au début des lignes (sauf la première et la dernière) et renseigner en fonction des adresses IP voulues: ipv4 et ipv6.

Il restera les serveurs DNS à configurer (dernière ligne), ce que nous ferons après avoir installé **knot-resolver**.

Une fois les modifications dans le fichier **/etc/dhcpcd.conf** faites, vous pouvez re-démarrer votre raspi.

Test:

    pi@raspberrypi:~ $ ip a
    1: lo: <LOOPBACK,UP,LOWER_UP> mtu 65536 qdisc noqueue state UNKNOWN group default qlen 1000
        link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00
        inet 127.0.0.1/8 scope host lo
        valid_lft forever preferred_lft forever
        inet6 ::1/128 scope host 
        valid_lft forever preferred_lft forever
    2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP group default qlen 1000
        link/ether b8:27:eb:3a:0b:38 brd ff:ff:ff:ff:ff:ff
        inet 192.168.111.170/24 brd 192.168.111.255 scope global noprefixroute eth0
        valid_lft forever preferred_lft forever
        inet6 2a01:e0a:d0:3c20:a23:93ca:de95:e15b/64 scope global dynamic mngtmpaddr noprefixroute 
        valid_lft 86388sec preferred_lft 86388sec
        inet6 2a01:e0a:d0:3c20::170/64 scope global noprefixroute 
        valid_lft forever preferred_lft forever
        inet6 fe80::74c8:34d:25f2:3b43/64 scope link 
        valid_lft forever preferred_lft forever
    pi@raspberrypi:~ $ 

Les adresses IP de votre serveur doivent correspondre à ce que vous avez entré dans le fichier. On a bien:

* inet 192.168.111.170/24
* inet6 2a01:e0a:d0:3c20::170/64

C'est tout bon!