
# Boot en mode root avec clef ssh

Lors du choix du système d'exploitation et des paramètres de l'installation, vous avez le choix entre *se faire envoyer par émail les identifiants/mots de passe* ou fournir votre clef *SSH* publique. Choisissez cette dernière option si vous le pouvez.

Evidemment, il vous faut une clef **SSH**. Si vous n'en avez pas encore, voyez dans le chapitre [Première étape de sécurisation](5-Première-Etape-Sécurisation.md) où cette étape est décrite en détail.

Il suffit de copier/coller l'empreinte de la clef publique dans l'emplacement prévu dans les paramètres.

Exemple (pour ma clef généraliste):

    eric@aldebaran:~$ cat .ssh/id_ed25519.pub 
    ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIL2quh1K3jSwBiUC+jYgOQCaVteYo/ir9ivZ7Qr+Hbg9 eric@aldebaran
    eric@aldebaran:~$ 

Collez la partie qui commence par **ssh-** et finit par votre adresse émail et collez-là dans l'emplacement prévu dans la console d'administration.

Il est toujours possible de procéder à cet ajout ultérieurement.

    eric@aldebaran:~$ ssh root@91.127.72.12
    The authenticity of host '91.127.72.12 (91.127.72.12)' can't be established.
    ECDSA key fingerprint is SHA256:eBYgeGPntU9stGkYe5GLltv46hCeVDRIu8xic3MDLbE.
    Are you sure you want to continue connecting (yes/no)? yes
    Warning: Permanently added '91.127.72.12' (ECDSA) to the list of known hosts.
    Linux adara 4.9.103-xxxx-std-ipv6-64 #222672 SMP Mon Jun 4 15:16:03 UTC 2018 x86_64

        Debian GNU/Linux 9 (stretch)

        Linux adara.yojik.eu 4.9.103-xxxx-std-ipv6-64 #222672 SMP Mon Jun 4 15:16:03 UTC 2018 x86_64 GNU/Linux


        Server      : 141519
        IPv4        : 91.127.72.12
        IPv6        : 2001:41d0:f:7d0d::1
        Hostname    : adara.yojik.eu

        Last login: Sun Jun 24 12:31:50 2018 from 217.182.145.216

Démarrez sur le serveur:

    eric@aldebaran:~$ ssh root@91.127.72.12
    The authenticity of host '91.127.72.12 (91.127.72.12)' can't be established.
    ECDSA key fingerprint is SHA256:BT4r+uaJ8qAVUKgquJ557W4wyFJ3cfqOy/qC838RKMw.
    Are you sure you want to continue connecting (yes/no)? yes
    Warning: Permanently added '91.127.72.12' (ECDSA) to the list of known hosts.
    Linux adara 4.9.103-xxxx-std-ipv6-64 #222672 SMP Mon Jun 4 15:16:03 UTC 2018 x86_64

      Debian GNU/Linux 9 (stretch)

      Linux adara.yojik.eu 4.9.103-xxxx-std-ipv6-64 #222672 SMP Mon Jun 4 15:16:03 UTC 2018 x86_64 GNU/Linux


      Server    : 141519
      IPv4      : 91.127.72.12
      IPv6      : 2001:41d0:f:7d0d::1
      Hostname  : adara.yojik.eu

    Last login: Sun Jun 24 13:00:53 2018 from 217.182.145.216

Date et heure: il faut reconfigurer tzdata

    root@adara:~# date
    dimanche 24 juin 2018, 12:33:18 (UTC+0000)
    root@adara:~# dpkg-reconfigure tzdata

    Current default time zone: 'Europe/Paris'
    Local time is now:      Sun Jun 24 14:33:42 CEST 2018.
    Universal Time is now:  Sun Jun 24 12:33:42 UTC 2018.

    root@adara:~#

Redémarrage et vérification de l'heure:

    root@adara:~# date
    dimanche 24 juin 2018, 14:40:39 (UTC+0200)

C'est bon.

# Installation sur serveur VPS de chez OVH

J'ai loué 2 serveurs VPS minimum pour installer mes serveurs DNS. La procédure est en tous points identique.

La seule différence est l'attribution d'un **user** **debian** avec les droits **sudo** d'administration. donc les commandes normalement sous le compte **root** seront préfixées par **sudo**.

Voir ci-dessus pour la clef **SSH** si vous n'en avez pas encore générée.

La suite des étapes est identique à celle de l'installation d'un **home server**.